#! /usr/bin/perl -w

use Net::HTTP;
use strict;
use HTML::Entities;

use vars qw($HOST $URL_OVERALL $TEAM_TOP_NUMBER $USER_TOP_NUMBER @TEAMID $TEAM_ID $URL_TEAM $URL_TEAM_TOP $URL_USER_TOP);
use vars qw($TOSKIP $buf $TEAMbuf $BTUbuf $BTTbuf $OVERALLbuf $UBtmp $TBtmp );
use vars qw($i $id $PC $TW $TTTB $TTUB $TTTBbTBT $TTUBbTBT);
use vars qw($TBS $TBT $BOR $TKS $TKT $KOR $CFT);
use vars qw($cmlarg $flag $value $tmp @values);
use vars qw(%Team_NAME %TR %TTR %TTB %TBR %BBM %TTK %TKR %KBM %TTW %TTKbTKT %NOT_KNOW);

############# dnet var ##############

$HOST = 'stats.distributed.net';
$URL_OVERALL = '/projects.php?project_id=8';
$URL_TEAM = '/team/tmsummary.php?project_id=8&team=';
$TEAM_TOP_NUMBER = 10;
$USER_TOP_NUMBER = 10;

############# fixed team ##############

#$TEAMID[0] = "85018234";         ## Undernet: #Mac-FR Rc5 Team
#$TEAMID[1] = "366";              ## Team EvangeLista (Macs Rule! :-)
#$TEAMID[2] = "10313";            ## Dutch Power Cows (number 1)

############# init ###############

$i=$PC=$TW=$TBS=$TBT=$BOR=$TKS=$TKT=$KOR=$CFT = 0;
$TTTB=$BTTbuf=$TTUB=$BTUbuf=$OVERALLbuf = 0;

# TBS -> Total Blocks to Search              # TBT -> Total Blocks Tested
# BOR -> Blocks Overall Rate                 # TKS -> Total Keys to Search
# TKT -> Total Keys Tested                   # KOR -> Keys Overall Rate
# PC  -> Percent Complete                    # TW  -> Time Working
# CFT -> Chance to Finish Tomorrow           # TR  -> Team Rank
# TTR -> Today Team Rank Delta               # TTB -> Total Team Block
# TBR -> Team Blocks Rate                    # BBM -> Blocks by Member
# TTK -> Total Team Keys                     # TKR -> Team Keys Rate
# KBM -> Keys by Member                      # TTW -> Team Time Working
# TTTB -> Top Total Team Block               # BTT -> Best Top Team
# TTUB -> Top Total User Block               # BTU -> Best Top User

######## cmd line parser  ###########

if (defined $ENV{REQUEST_METHOD}) {
	print "Content-type: text/html\n\n<html><body>\n";
	($tmp) = $ENV{'QUERY_STRING'};
	@values = split(/&/,$tmp);
}
else { @values = @ARGV; }

foreach $cmlarg (@values) {
	($flag,$value) = split(/=/,$cmlarg); 
	if ($flag eq "tt") { 
		if ($value =~ /^\d+$/) {
			if ( $value > 0 && $value < 101 ) { $TEAM_TOP_NUMBER = $value }
			else { &usage }
		}
		else { &usage } 
	}
	if ($flag eq "tu") {
		if ($value =~ /^\d+$/) {
			if ( $value > 0 && $value < 101 ) { $USER_TOP_NUMBER = $value }
			else { &usage }
		}
		else { &usage }
	}
	if ($flag eq "tid") {
		foreach $id (split(/,/,$value)) {
			push @TEAMID, $id;
		}
	}
	if ($flag =~ /-h/) { &usage }
}

$URL_TEAM_TOP = "/team/tlist.php?project_id=8&low=1&limit=$TEAM_TOP_NUMBER";
$URL_USER_TOP = "/participant/plist.php?project_id=8&low=1&limit=$USER_TOP_NUMBER";

######## CODE FOR OVERALL ###########

my $s = Net::HTTP->new(Host => "$HOST") || die $@;
$s->write_request(GET => "$URL_OVERALL", 'User-Agent' => "JPSM/0.1");
my($code, $mess, %h) = $s->read_response_headers;

while ($s->read_entity_body($buf, 1024)) {
	$OVERALLbuf = $OVERALLbuf . $buf;
}

foreach (split(/\n/,$OVERALLbuf)) {

	if ($TBS eq "-1") { $TBS = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Total Blocks to Search/) { $TBS = "-1" }

	if ($TBT eq "-1") { $TBT = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Total Blocks Tested/) { $TBT = "-1" }

	if ($BOR eq "-1" ) { $BOR = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Overall Rate/ && $BOR eq "0") { $BOR = "-1"; next }

	if ($TKS eq "-1" ) { $TKS = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Total Keys to Search/) { $TKS = "-1" }

	if ($TKT eq "-1" ) { $TKT = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Total Keys Tested/) { $TKT = "-1" }

	if ($KOR eq "-1" ) { $KOR = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Overall Rate/) { $KOR = "-1" }

	if ($PC eq "-1" ) { $PC = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Percent Complete/) { $PC = "-1" }

	if ($TW eq "-1" ) { $TW = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Time Working/) { $TW = "-1" }

	if ($_ =~ /The odds are 1 in (.*) that we will/) { $CFT = $1 }
}

if (defined $ENV{REQUEST_METHOD}) {
print STDOUT <<"EOF"; 
	Overall Stats<br>
Total Blocks to Search: $TBS<br>
Total Blocks Tested: $TBT<br>
Blocks Overall Rate: $BOR<br>
Total Keys to Search: $TKS<br>
Total Keys Tested: $TKT<br>
Keys Overall Rate: $KOR<br>
Percent Complete: $PC<br>
Time Working: $TW<br>
Chance to Finish Tomorrow: $CFT<br>
<br>
EOF
}
else {
print STDOUT <<"EOF";
	Overall Stats
Total Blocks to Search: $TBS
Total Blocks Tested: $TBT
Blocks Overall Rate: $BOR
Total Keys to Search: $TKS
Total Keys Tested: $TKT
Keys Overall Rate: $KOR
Percent Complete: $PC
Time Working: $TW
Chance to Finish Tomorrow: $CFT

EOF
}

$TKT =~ s/,//g ;


############### TEAM CODE ################

foreach $TEAM_ID (@TEAMID) {

($TR{$TEAM_ID},$TTR{$TEAM_ID},$TTB{$TEAM_ID},$TBR{$TEAM_ID},$BBM{$TEAM_ID},$TTK{$TEAM_ID},$TKR{$TEAM_ID},$KBM{$TEAM_ID},$TTW{$TEAM_ID},$Team_NAME{$TEAM_ID},$NOT_KNOW{$TEAM_ID}) = (0,0,0,0,0,0,0,0,0,0,0);
my ($TEAMbuf);

my $s2 = Net::HTTP->new(Host => "$HOST") || die $@;
$s2->write_request(GET => "$URL_TEAM" . "$TEAM_ID", 'User-Agent' => "JPSM/0.1");
my($code2, $mess2, %h2) = $s2->read_response_headers;

while ($s2->read_entity_body($buf, 1024)) {
        $TEAMbuf = $TEAMbuf . $buf;
}   

foreach (split(/\n/,$TEAMbuf)) {
	if ($TR{$TEAM_ID} eq "-1" ) { $TR{$TEAM_ID} = "$1" and $TTR{$TEAM_ID} = $2 . $3 if ($_ =~ /new\">(.*) <font .*alt=\"(.)\">(\d+)\)/) }
	if ($TR{$TEAM_ID} eq "-1" ) { $TR{$TEAM_ID} = "$1" and $TTR{$TEAM_ID} = "0" if ($_ =~ /new\">(.*) <\/font><\/td>/) }
	if ($_ =~ /Rank:/) { $TR{$TEAM_ID} = "-1" }

	if ($TTB{$TEAM_ID} eq "-1" ) { $TTB{$TEAM_ID} = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Blocks:/) { $TTB{$TEAM_ID} = "-1" }

	if ($TBR{$TEAM_ID} eq "-1" ) { $TBR{$TEAM_ID} = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Blocks\/sec:/) { $TBR{$TEAM_ID} = "-1" }

	if ($BBM{$TEAM_ID} eq "-1" ) { $BBM{$TEAM_ID} = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Blocks\/member:/) { $BBM{$TEAM_ID} = "-1" }

	if ($TTK{$TEAM_ID} eq "-1" ) { $TTK{$TEAM_ID} = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Keys:/) { $TTK{$TEAM_ID} = "-1" }

	if ($TKR{$TEAM_ID} eq "-1" ) { $TKR{$TEAM_ID} = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Keys\/sec:/) { $TKR{$TEAM_ID} = "-1" }

	if ($KBM{$TEAM_ID} eq "-1" ) { $KBM{$TEAM_ID} = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Keys\/member:/) { $KBM{$TEAM_ID} = "-1" }

	if ($TTW{$TEAM_ID} eq "-1" ) { $TTW{$TEAM_ID} = "$1" if ($_ =~ /new\">(.*)<\/font><\/td>$/) }
	if ($_ =~ /Time Working:/) { $TTW{$TEAM_ID} = "-1" }

	$Team_NAME{$TEAM_ID} = $1 if ($_ =~ /<h1><center>(.*)<\/center><\/h1>/);
	$NOT_KNOW{$TEAM_ID} = 1 if ($_ =~ /<H2>That team is not known.<\/H2>/);
}

$TTK{$TEAM_ID} =~ s/,//g ;
$TTKbTKT{$TEAM_ID} = 100*($TTK{$TEAM_ID}/$TKT);
$TTKbTKT{$TEAM_ID} =~ /(\d+\.\d{4})/;
$TTKbTKT{$TEAM_ID} = $1;

}

if (defined $ENV{REQUEST_METHOD}) {
	my ($HTML_Team_NAME,$HTML_TEAM_ID,$HTML_TR,$HTML_TTB,$HTML_TBR,$HTML_BBM,$HTML_TTK,$HTML_TKR,$HTML_KBM,$HTML_TTW,$HTML_TTKbTKT);

	foreach $TEAM_ID (@TEAMID) {
		if ($NOT_KNOW{$TEAM_ID}) { $HTML_Team_NAME = $HTML_Team_NAME . "<td>Not Found</td>"; }
		else { $HTML_Team_NAME = $HTML_Team_NAME . "<td>$Team_NAME{$TEAM_ID}</td>"; }
		$HTML_TEAM_ID = $HTML_TEAM_ID . "<td>#$TEAM_ID</td>";
		$HTML_TR = $HTML_TR . "<td>$TR{$TEAM_ID},$TTR{$TEAM_ID}</td>";
		$HTML_TTB = $HTML_TTB . "<td>$TTB{$TEAM_ID}</td>";
		$HTML_TBR = $HTML_TBR . "<td>$TBR{$TEAM_ID}</td>";
		$HTML_BBM = $HTML_BBM . "<td>$BBM{$TEAM_ID}</td>";
		$HTML_TTK = $HTML_TTK . "<td>$TTK{$TEAM_ID}</td>";
		$HTML_TKR = $HTML_TKR . "<td>$TKR{$TEAM_ID}</td>";
		$HTML_KBM = $HTML_KBM . "<td>$KBM{$TEAM_ID}</td>";
		$HTML_TTW = $HTML_TTW . "<td>$TTW{$TEAM_ID}</td>";
		$HTML_TTKbTKT = $HTML_TTKbTKT . "<td>$TTKbTKT{$TEAM_ID} %</td>";
	}
print STDOUT <<"EOF";
<table width="100%" border="0" align="center">
<tr><td>Team:</td>$HTML_Team_NAME</tr>
<tr><td>ID:</td>$HTML_TEAM_ID</tr>
<tr><td>Team Rank, Today delta</td>$HTML_TR</tr>
<tr><td>Total Team Block</td>$HTML_TTB</tr>
<tr><td>Team Blocks Rate</td>$HTML_TBR</tr>
<tr><td>Blocks by Member</td>$HTML_BBM</tr>
<tr><td>Total Team Keys</td>$HTML_TTK</tr>
<tr><td>Team Keys Rate</td>$HTML_TKR</tr>
<tr><td>Keys by Member</td>$HTML_KBM</tr>
<tr><td>eam Time Working</td>$HTML_TTW</tr>
<tr><td>Total Team Key / Total Keys Tested</td>$HTML_TTKbTKT</tr>
</table>
<br>
EOF
}

else {
	foreach $TEAM_ID (@TEAMID) {
		decode_entities($Team_NAME{$TEAM_ID});
		if ($NOT_KNOW{$TEAM_ID}) { print STDOUT "Team: #$TEAM_ID Not Found\n\n" }
		else {
print STDOUT <<"EOF";
	Team: $Team_NAME{$TEAM_ID}	ID: #$TEAM_ID
Team Rank: $TR{$TEAM_ID}, $TTR{$TEAM_ID} Today
Total Team Block: $TTB{$TEAM_ID}
Team Blocks Rate: $TBR{$TEAM_ID}
Blocks by Member: $BBM{$TEAM_ID}
Total Team Keys: $TTK{$TEAM_ID}
Team Keys Rate: $TKR{$TEAM_ID}
Keys by Member: $KBM{$TEAM_ID}
Team Time Working: $TTW{$TEAM_ID}
Total Team Key / Total Keys Tested: $TTKbTKT{$TEAM_ID} %

EOF
		}
	}
}

########### ADD BEST TEAM CODE ############

my $st = Net::HTTP->new(Host => "$HOST") || die $@;
$st->write_request(GET => "$URL_TEAM_TOP", 'User-Agent' => "JPSM/0.1");
my($tcode, $tmess, %th) = $st->read_response_headers;
        
while ($st->read_entity_body($buf, 1024)) {
        $BTTbuf = $BTTbuf . $buf;
}

$TOSKIP = "-1";
foreach (split(/\n/,$BTTbuf)) {
my ($TBtmp) = 0;
	if ($TOSKIP eq "0" ) {
		$TBtmp = "$1" if ($_ =~ />(.*)<\/td>/); 
		$TBtmp =~ s/,//g ;
		$TTTB = $TTTB + $TBtmp;
		$TOSKIP = "-1";
	}
	else { $TOSKIP-- }
	if ($_ =~ /<td><a href=/) { $TOSKIP = "4"; }
}

$TBT =~ s/,//g ;
$TTTBbTBT = 100*($TTTB/$TBT);
$TTTBbTBT =~ /(\d+\.\d{4})/;
$TTTBbTBT = $1;

if (defined $ENV{REQUEST_METHOD}) { print "Total Top $TEAM_TOP_NUMBER Team Blocks / Total Blocks Tested : $TTTBbTBT %<br>"; }
else { print "Total Top $TEAM_TOP_NUMBER Team Blocks / Total Blocks Tested : $TTTBbTBT %\n"; }

########### ADD BEST USER CODE #############

my $su = Net::HTTP->new(Host => "$HOST") || die $@;
$su->write_request(GET => "$URL_USER_TOP", 'User-Agent' => "JPSM/0.1");
my($ucode, $umess, %uh) = $su->read_response_headers;
        
while ($su->read_entity_body($buf, 1024)) {
        $BTUbuf = $BTUbuf . $buf;
} 

$TOSKIP = "-1";
foreach (split(/\n/,$BTUbuf)) {
my ($UBtmp) = 0;
        if ($TOSKIP eq "0" ) {
                $UBtmp = "$1" if ($_ =~ />(.*)<\/td>/);
                $UBtmp =~ s/,//g ;
                $TTUB = $TTUB + $UBtmp;
                $TOSKIP = "-1";
        }
        else { $TOSKIP-- }
        if ($_ =~ /<a href=.*<font color=.*<\/font><\/a><\/td>$/) { $TOSKIP = "3"; }
}

$TTUBbTBT = 100*($TTUB/$TBT);
$TTUBbTBT =~ /(\d+\.\d{4})/;
$TTUBbTBT = $1;

if (defined $ENV{REQUEST_METHOD}) {print "Total Top $USER_TOP_NUMBER User Blocks / Total Blocks Tested : $TTUBbTBT %<br>"; }
else { print "Total Top $USER_TOP_NUMBER User Blocks / Total Blocks Tested : $TTUBbTBT %\n"; }

############ Usage #############

sub usage {
print <<"EOF";
Usage: $0 [option-1] [option-2] ... [option-N]
Version 0.1 by Jean-Edouard BABIN -> Jeb\@jeb.com.fr

Options:

	tt=integer
			Use 'integer' first team to do:
			Total Top 'integer' Team Blocks / Total Blocks Tested
			where 0 < integer < 101

	tu=integer
			Use 'integer' first userto do: 
			Total Top 'integer' User Blocks / Total Blocks Tested
			where 0 < integer < 101

	tid=ID1,ID2,...,IDn
			List of Team ID to get Stats

EOF

exit 0;

}
